 
import java.util.*;
import java.io.*;

/**
 * FichaAluno  uma classe que permite criar Fichas de Informao
 * sobre Alunos, contendo o seu nmero, nome, mdia e uma lista
 * contendo os nomes das disciplinas a que est inscrito.
 * 
 * @author F. Mrio Martins
 * @version 03/04/2005
 */

public class FichaAluno {

	// variveis de instncia
	
	private String numero;
	private String nome;
	private double media;
	private ArrayList<String> discp;
	

	/**
	 * Construtores 
	 */
	
	public FichaAluno() {		
		numero = "";
		nome = "";
		media = 0.0;
		discp = new ArrayList();		
	}
	
    public FichaAluno(String cod, String nom, double classif, 
                      ArrayList<String> ldiscp) {		
		numero = cod;
		nome = nom;
		media = classif;
		discp = ldiscp;		
	}
	
   // Mtodos de instncia
   
   /**
    * Devolve o nmero do aluno
    */
   
   public String getNumero(){ return numero;}
   
   /**
    * Devolve o Nome do aluno
    */
   
   public String getNome(){ return nome;}
   
    /**
    * Devolve a mdia actual do aluno
    */
   
   public double getMedia(){ return media;}
   
   /**
    * Devolve o ArrayList<String> das disciplinas a que 
    * o aluno est inscrito.
    */
   
   public ArrayList<String> getDiscp(){
        ArrayList<String> dsp = new ArrayList<String>();
        for(String nome : discp) { dsp.add(nome); }
        return dsp;
   } 
   
   /**
	* Verifica se o aluno est inscrito a dada disciplina
	*/

   public boolean inscritoA(String disciplina) {
       return discp.contains(disciplina);
    }
      
    /**
	* Devolve o nmero de disciplinas a que o aluno est inscrito
	*/
    public int numInscricoes() {
       return discp.size();
    }

   // Modificadores
	
	/**
	* Altera o nome do aluno
	*/   
    public void mudaNome(String name){ nome = name;}
    
    /**
	 * Altera a mdia do aluno
	 */   
    public void novaMedia(double classif){ media = classif;}
    
    /**
	 * Inscreve o aluno a mais uma disciplina, caso ainda no esteja
	 * inscrito na mesma (usar inscritoA(novaDiscp) antes de invocar
	 * este mtodo !!).
	 */   
    
    public void inscreveA(String novaDiscp) {
          discp.add(novaDiscp);
    }
    
    /**
     * toString()
     */
    public String toString() {
        StringBuffer s = new StringBuffer();
        s.append(" --- FICHA DO ALUNO N: ");
        s.append(numero); s.append("\n");
        s.append("NOME : "); s.append(nome); s.append("\n");
        s.append("MEDIA : "); s.append(media); s.append("\n");
        s.append("---------  INSCRITO A -------------------\n");
        for(String nome : discp) {
            s.append(nome) ; s.append("\n");
        }
        return s.toString();
    }
    
    /**
     * Clone
     */
    public Object clone() {
        return new FichaAluno(numero, nome, 
                              media, this.getDiscp());
    }   
}
	
	