 
import java.util.*;

/**
 * 
 * TurmaHash = HashMap(Numero do Aluno(String) -> FichaAluno)
 * 
 * @author F. Mrio Martins
 * @version 1.0/01/2005
 */
public class TurmaHash {

    private HashMap<String, FichaAluno> turma; 
		
	/**
	 * Construtor por omisso 
	 */	
	public TurmaHash() { 
	    turma = new HashMap<String, FichaAluno>();
	}
	
	
	// Mtodos de Instncia
	  
   /**
	 *  Insere um novo aluno na turma. O mtodo  consistente dado 
	 *  que o nmero de aluno  garantidamente igual ao que consta
	 *  da sua ficha !!
	 */

    public void insereAluno(FichaAluno ficha) {		
		turma.put(ficha.getNumero(), (FichaAluno) ficha.clone());
    }

    /**
	 *  Remove o aluno cujo nmero  dado como parmetro
	 *  
	 */	
	public void removeAluno(String codAluno) {
	     turma.remove(codAluno);
	}
	
	/**
	 *  Devolve o nmero actual de alunos da turma
	 */
         public int numAlunos() { return turma.size(); }
	
	/**
	 *  Determina a  maiorNota da turma
	 */
	
	public double maiorNotaTurma() {	    
	double maiorMedia = -1.0;	
   	Collection<FichaAluno> fichas = turma.values();
	for(FichaAluno ficha : fichas) {
	     if( ficha.getMedia() > maiorMedia ) 
	          maiorMedia = ficha.getMedia();
	 }	 
	 return maiorMedia;
    }
    
    /**
     * Devolve um ArrayList com os cdigos dos alunos
     */
    public ArrayList<String> codigos() {	    
	  ArrayList<String> cods = new ArrayList();	  	
	  for(FichaAluno ficha: turma.values()) {
	     cods.add(ficha.getNumero());
	 }	 
	 return cods;
    }
  
    /**
	 * Verifica se um dado aluno cujo cdigo  dado est registado
	 */
	
	public boolean existeAluno(String numAluno) {
	    return turma.keySet().contains(numAluno);
	}
		   
     /**
	 *  Cria a lista com os cdigos dos alunos com nota superior  dada
	 *  como parmetro (ex cdigos dos alunos com nota > 12).
	 */
	public ArrayList<String> alunosNotaSuperior(double notaRef) {	    
	 ArrayList<String> codigos = new ArrayList<String>();
   	 Collection<FichaAluno> fichas = turma.values();	
	 for(FichaAluno ficha: fichas) {
	      if( ficha.getMedia() > notaRef ) codigos.add(ficha.getNumero()) ;	         
	 }	 
	 return codigos;
   }
   
    /**
     * toString()
     */
    public String toString() {
        Collection<FichaAluno> fichas = turma.values();
        StringBuffer s = new StringBuffer();
        s.append("-----------  TURMA --------------------\n");
        for(FichaAluno ficha : fichas) {
	       s.append(ficha.toString());   
	   }
	   return s.toString();
    }  
 }




	
	